# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.service_client import SDKClient
from msrest import Configuration, Serializer, Deserializer
from .version import VERSION
from msrest.exceptions import HttpOperationError
from .operations.account_operations import AccountOperations
from .operations.import_model_operations import ImportModelOperations
from .operations.activation_operations import ActivationOperations
from .operations.tags_operations import TagsOperations
from .operations.language_operations import LanguageOperations
from . import models


class DapresyDataAPIDocumentationConfiguration(Configuration):
    """Configuration for DapresyDataAPIDocumentation
    Note that all parameters used to create this instance are saved as instance
    attributes.

    :param str base_url: Service URL
    """

    def __init__(
            self, base_url=None):

        if not base_url:
            base_url = 'https://devs-dataapi.dapresy.com:27015'

        super(DapresyDataAPIDocumentationConfiguration, self).__init__(base_url)

        self.add_user_agent('dapresydataapidocumentation/{}'.format(VERSION))


class DapresyDataAPIDocumentation(SDKClient):
    """DapresyDataAPIDocumentation

    :ivar config: Configuration for client.
    :vartype config: DapresyDataAPIDocumentationConfiguration

    :ivar account: Account operations
    :vartype account: dataapiclient.operations.AccountOperations
    :ivar import_model: ImportModel operations
    :vartype import_model: dataapiclient.operations.ImportModelOperations
    :ivar activation: Activation operations
    :vartype activation: dataapiclient.operations.ActivationOperations
    :ivar tags: Tags operations
    :vartype tags: dataapiclient.operations.TagsOperations
    :ivar language: Language operations
    :vartype language: dataapiclient.operations.LanguageOperations

    :param str base_url: Service URL
    """

    def __init__(
            self, base_url=None):

        self.config = DapresyDataAPIDocumentationConfiguration(base_url)
        super(DapresyDataAPIDocumentation, self).__init__(None, self.config)

        client_models = {k: v for k, v in models.__dict__.items() if isinstance(v, type)}
        self.api_version = 'V1'
        self._serialize = Serializer(client_models)
        self._deserialize = Deserializer(client_models)

        self.account = AccountOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.import_model = ImportModelOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.activation = ActivationOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.tags = TagsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.language = LanguageOperations(
            self._client, self.config, self._serialize, self._deserialize)
